import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgrTreemapNodeStyle } from "./igr-treemap-node-style";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-react-core/ES2015/componentUtil";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export class IgrTreemapNodeStyleMapping extends IgrTreemapNodeStyle {
    createImplementation() {
        return new TreemapNodeStyleMapping();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name() {
        return this.i.a8;
    }
    set name(v) {
        this.i.a8 = v;
    }
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    get minimumValue() {
        return this.i.a1;
    }
    set minimumValue(v) {
        this.i.a1 = +v;
    }
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    get maximumValue() {
        return this.i.a0;
    }
    set maximumValue(v) {
        this.i.a0 = +v;
    }
    /**
     * Gets or sets the value to which the mapping applies.
    */
    get value() {
        return this.i.a3;
    }
    set value(v) {
        this.i.a3 = v;
    }
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    get mappingMode() {
        return this.i.ax;
    }
    set mappingMode(v) {
        this.i.ax = ensureEnum(TreemapValueMappingMode_$type, v);
    }
}
