import * as tslib_1 from "tslib";
import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgrTreemapNodeStyle } from "./igr-treemap-node-style";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-react-core/ES5/componentUtil";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
var IgrTreemapNodeStyleMapping = /** @class */ (function (_super) {
    tslib_1.__extends(IgrTreemapNodeStyleMapping, _super);
    function IgrTreemapNodeStyleMapping(props) {
        return _super.call(this, props) || this;
    }
    IgrTreemapNodeStyleMapping.prototype.createImplementation = function () {
        return new TreemapNodeStyleMapping();
    };
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "name", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.a8;
        },
        set: function (v) {
            this.i.a8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get: function () {
            return this.i.a0;
        },
        set: function (v) {
            this.i.a0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "value", {
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "mappingMode", {
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureEnum(TreemapValueMappingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemapNodeStyleMapping;
}(IgrTreemapNodeStyle));
export { IgrTreemapNodeStyleMapping };
